.pl 10.0i
.po 0
.ll 72n
.lt 72n
.nr LL 72n
.nr LT 72n
.nr PI 3n
.de FO
'bp
..
.      \" SH - section header
.de SH
.ti \\n(.iu
.RT
.if \\n(1T .sp
.RT
.ne 3.1
..
.      \" Nh - Numbered Header (NH) with TOC
.de Nh
.RT
.if \\n(1T .sp
.if !\\n(1T .BG
.RT
.ne 3.1
.nr NS \\$1
.if !\\n(.$ .nr NS 1
.if !\\n(NS .nr NS 1
.nr H\\n(NS +1
.if !\\n(NS-4 .nr H5 0
.if !\\n(NS-3 .nr H4 0
.if !\\n(NS-2 .nr H3 0
.if !\\n(NS-1 .nr H2 0
.if !\\$1 .if \\n(.$ .nr H1 1
.if \\$1S \{\
.      nr NS \\n(.$-1
.      nr H1 \\$2
.      nr H2 \\$3
.      nr H3 \\$4
.      nr H4 \\$5
.      nr H5 \\$6
.\}
.ds SN \\n(H1
.ti \\n(.iu
.if \\n(NS-1 .as SN .\\n(H2
.if \\n(NS-2 .as SN .\\n(H3
.if \\n(NS-3 .as SN .\\n(H4
.if \\n(NS-4 .as SN .\\n(H5
\\*(SN.  \\$2 \\$3 \\$4 \\$5 \\$6 \\$7 \\$8 \\$9
.br
.\" TOC
.\" (non-top-level sections)
.ie \\n(NS-1 \{\
.      nr Pd \\n(PD
.      nr PD 0
.      XS
.      nr jj \\n(NS-1*3+5
\h'|\\n(jjn'\\*(SN\h'|18n'\\$2 \\$3 \\$4 \\$5 \\$6 \\$7 \\$8 \\$9
.      XE
.      nr PD \\n(Pd
.\}
.\" (top-level sections)
.el \{\
.      XS
\h'|5n'\\*(SN.\h'|12n'\\$2 \\$3 \\$4 \\$5 \\$6 \\$7 \\$8 \\$9
.      XE
.\}
..
.de XX
.XS
\h'|5n'\\$1 \\$2 \\$3 \\$4 \\$5 \\$6 \\$7 \\$8 \\$9
.XE
..
.ds LF McGregor
.ds CF
.ds RF FORMFEED[Page \\n(PN]
.ds LH RFC DRAFT
.ds CH PPP IPCP
.ds RH \*(MO 19\n(yr
.ad l
.LP
.tl 'Network Working Group''G McGregor'
.tl 'Request for Comments: DRAFT''Merit'
.tl 'Obsoletes: RFC 1172''\*(MO 19\n(yr'
.sp 2
.\"    for -ms, must turn off hyphenation after first para (sigh)
.hy 0
.af PN i
.sp
.ce
The PPP Internet Protocol Control Protocol (IPCP)
.sp 2
.SH
Status of this Memo
.RS
.LP
This RFC specifies an IAB standards track protocol for the Internet community.
.LP
Please refer to the current edition of the "IAB Official Protocol
Standards" for the standardization state and status of this protocol.
.LP
This proposal is the product of the Point-to-Point Protocol Working Group
of the Internet Engineering Task Force (IETF).
Comments on this memo should be submitted to the
ietf-ppp@ucdavis.edu mailing list.
.LP
Distribution of this memo is unlimited.
.RE
.SH
Abstract
.RS
.LP
The Point-to-Point Protocol (PPP) [1] provides a standard method of
encapsulating Network Layer protocol
information over point-to-point links.
PPP also defines an extensible Link Control Protocol,
and proposes a family of Network Control Protocols (NCPs)
for establishing and configuring different network-layer protocols.
.LP
This document defines the NCP for establishing and configuring
the Internet Protocol [2] over PPP,
and a method to negotiate and use Van Jacobson
TCP/IP header compression [3] with PPP.
.RE
.nr Pn \n%+1
.P1
.bp 1
.af PN 1
.Nh 1 Introduction
.LP
.RS
PPP has three main components:
.RS
.IP 1.
A method for encapsulating datagrams over serial links.
.IP 2.
A Link Control Protocol (LCP) for establishing,
configuring, and testing the data-link connection.
.IP 3.
A family of Network Control Protocols (NCPs) for establishing
and configuring different network-layer protocols.
.RE
.LP
In order to establish communications over a point-to-point link,
each end of the PPP link must first send LCP packets
to configure and test the data link.
After the link has been established and optional facilities
have been negotiated as needed by the LCP,
PPP must send NCP packets
to choose and configure one or more network-layer protocols.
Once each of the chosen network-layer protocols has been configured,
datagrams from each network-layer protocol can be sent over the link.
.LP
The link will remain configured for communications until explicit LCP or
NCP packets close the link down, or until some external event occurs
(an inactivity timer expires or network administrator intervention).
.RE
.RE
.bp
.Nh 1 A PPP Network Control Protocol (NCP) for IP
.LP
.RS
The IP Control Protocol (IPCP) is responsible for configuring,
enabling, and disabling the IP protocol modules on both ends of
the point-to-point link.
IPCP uses the same packet exchange machanism
as the Link Control Protocol (LCP).
IPCP packets may not be exchanged until PPP has reached the
Network-Layer Protocol phase.
IPCP packets received before this phase is reached should be silently
discarded.
.LP
The IP Control Protocol is exactly the same as the
Link Control Protocol [1]
with the following exceptions:
.SH
Data Link Layer Protocol Field
.LP
.RS
Exactly one IPCP packet is encapsulated in the Information
field of PPP Data Link Layer frames where the Protocol field indicates
type hex 8021 (IP Control Protocol).
.RE
.SH
Code field
.LP
.RS
Only Codes 1 through 7 (Configure-Request, Configure-Ack, Configure-Nak,
Configure-Reject, Terminate-Request, Terminate-Ack and Code-Reject)
are used.  Other Codes should be treated as unrecognized and should result
in Code-Rejects.
.RE
.SH
Timeouts
.LP
.RS
IPCP packets may not be exchanged until PPP
has reached the Network-Layer Protocol phase.
An implementation should be prepared to wait for
Authentication and Link Quality Determination
to finish before timing out waiting for a Configure-Ack or other
response.  It is suggested that an implementation give up only after
user intervention or a configurable amount of time.
.RE
.SH
Configuration Option Types
.LP
.RS
IPCP has a distinct set of Configuration Options,
which are defined below.
.RE
.RE
.Nh 2 Sending IP Datagrams
.RS
.LP
Before any IP packets may be communicated,
PPP must reach the Network-Layer Protocol phase,
and the IP Control Protocol must reach the Opened state.
.LP
Exactly one IP packet is encapsulated in the Information
field of PPP Data Link Layer frames where the Protocol field indicates
type hex 0021 (Internet Protocol).
.LP
The maximum length of an IP packet transmitted over a PPP link is the
same as the maximum length of the Information field of a PPP data link
layer frame.  Larger IP datagrams must be fragmented as necessary.
If a system wishes to avoid fragmentation and reassembly, it should use
the TCP Maximum Segment Size option [4], and MTU discovery [5].
.RE
.RE
.bp
.Nh 1 IPCP Configuration Options
.LP
IPCP Configuration Options allow negotiatiation of desirable Internet
Protocol parameters.
IPCP uses the same Configuration Option format defined for LCP [1],
with a separate set of Options.
.LP
The most up-to-date values of the IPCP Option Type field
are specified in the most recent "Assigned Numbers" RFC [6].
Current values are assigned as follows:
.LP
.RS
.nf
1       IP-Addresses
2       IP-Compression-Protocol
3	IP-Address
.fi
.RE
.RE
.bp
.Nh 2 IP-Addresses
.LP
.RS
Description
.LP
.RS
The use of the Configuration Option IP-Addresses has been deprecated.
It has been determined through implementation experience that it is
difficult to ensure negotiation convergence in all cases using this
option.
RFC 1172 [7] provides information for implementations requiring
backwards compatability.
The IP-Address Configuration Option replaces
this option, and its use is preferred.
.LP
This option SHOULD NOT be sent in a Configure-Request
if a Configure-Request has been received
which includes either an IP-Addresses or IP-Address option.
This option MAY be sent if a Configure-Reject is received for
the IP-Address option, or a Configure-Nak is received with
an IP-Addresses option as an appended option.
.LP
Support for this option MAY be removed after the IPCP protocol status
advances to Internet Draft Standard.
.RE
.SH
.RE
.bp
.Nh 2 IP-Compression-Protocol
.LP
.RS
Description
.LP
.RS
This Configuration Option provides a way to negotiate the use of a
specific compression protocol.  By default, compression is not
enabled.
.RE
.LP
A summary of the IP-Compression-Protocol Configuration Option format
is shown below.  The fields are transmitted from left to right.
.LP
.nf
 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     Type      |    Length     |     IP-Compression-Protocol   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|    Data ...
+-+-+-+-+
.fi
.SH
Type
.LP
.RS
2
.RE
.SH
Length
.LP
.RS
>= 4
.RE
.SH
IP-Compression-Protocol
.LP
.RS
The IP-Compression-Protocol field is two octets and indicates the
compression protocol desired.  Values for this field
are always the same as the PPP Data Link Layer Protocol field values
for that same compression protocol.
.LP
The most up-to-date values of the IP-Compression-Protocol field
are specified in the most recent "Assigned Numbers" RFC [6].
Current values are assigned as follows:
.LP
.RS
.nf
Value (in hex)          Protocol

002d                    Van Jacobson Compressed TCP/IP
.fi
.RE
.RE
.SH
Data
.LP
.RS
The Data field is zero or more octets and contains additional data as
determined by the particular compression protocol.
.RE
.SH
Default
.LP
.RS
No compression protocol enabled.
.RE
.SH
.RE
.bp
.Nh 2 IP-Address
.LP
.RS
Description
.LP
.RS
This Configuration Option provides a way to negotiate the IP address
to be used on the local end of the link.  It allows the sender of the
Configure-Request to state which IP-address is desired, or to request
that the peer provide the information.	The peer can provide this information
by NAKing the option, and returning a valid IP-address.
.LP
If negotiation about the remote IP-address is required, and the peer
did not provide the option in its Configure-Request, the option
SHOULD be appended to a Configure-Nak.
The value of the IP-address given must be acceptable as the remote IP-address,
or indicate a request that the peer provide the information.
.LP
By default, no IP address is assigned.  
.RE
.LP
A summary of the IP-Address Configuration Option format
is shown below.  The fields are transmitted from left to right.
.LP
.nf
 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     Type      |    Length     |           IP-Address 
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
        IP-Address (cont)       |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
.fi
.SH
Type
.LP
.RS
3
.RE
.SH
Length
.LP
.RS
6
.RE
.SH
IP-Address
.LP
.RS
The four octet IP-Address is the desired local address of
the sender of a Configure-Request. If all four octets are set to zero, 
it indicates a request that the peer provide the IP-Address information.
.RE
.SH
Default
.LP
.RS
No IP address is assigned.
.RE
.SH
.RE
.bp
.Nh 1 Van Jacobson TCP/IP header compression
.LP
Van Jacobson TCP/IP header compression reduces the size of the TCP/IP
headers to as few as three bytes. This can be a significant
improvement on slow serial lines, particularly for interactive
traffic.
.LP
The IP-Compression-Protocol Configuration Option
is used to indicate the ability to
receive compressed packets. Each end of the link must seperately request this
option if bi-directional compression is desired.
.LP
The PPP Protocol field is set to the following values when
transmitting IP packets:
.LP
.RS
.nf
Value (in hex)

0021	  Type IP.  The IP protocol is not TCP, or the packet is a
          fragment, or cannot be compressed.

002d	  Compressed TCP.  The TCP/IP headers are replaced by the
          compressed header.

002f      Uncompressed TCP.  The IP protocol field is replaced by
          the slot identifier.
.fi
.RE
.RE
.Nh 2 Configuration Option Format
.LP
.RS
A summary of the IP-Compression-Protocol Configuration Option format
to negotiate Van Jacobson TCP/IP header compression
is shown below.
The fields are transmitted from left to right.
.LP
.nf
 0                   1                   2                   3
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|     Type      |    Length     |     IP-Compression-Protocol   |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
|  Max-Slot-Id  | Comp-Slot-Id  |
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
.fi
.SH
Type
.LP
.RS
2
.RE
.SH
Length
.LP
.RS
6
.RE
.SH
IP-Compression-Protocol
.LP
.RS
002d (hex) for Van Jacobson Compressed TCP/IP headers.
.RE
.SH
Max-Slot-Id
.LP
.RS
The Max-Slot-Id field is one octet and indicates the maximum slot
identifier.  This is one less than the actual number of slots; the slot
identifier has values from zero to Max-Slot-Id.
.LP
.RS
Note:
There may be implementations that have problems with only one slot
(Max-Slot-Id = 0).  See the discussion in reference [3].  The example
implementation in [3] will only work with 3 through 254 slots.
.RE
.RE
.SH
Comp-Slot-Id
.LP
.RS
The Comp-Slot-Id field is one octet and indicates whether the slot
identifier field may be compressed.
.RS
.IP 0
The slot identifier must not be compressed.  All
compressed TCP packets must set the C bit in every
change mask, and must include the slot identifier.
.IP 1
The slot identifer may be compressed.
.RE
.LP
The slot identifier must not be compressed if there is no ability
for the PPP link level to indicate an error in reception to the
decompression module.  Synchronization after errors depends on
receiving a packet with the slot identifier.  See the discussion
in reference [3].
.RE
.SH
.RE
.bp
.XX APPENDICES
.af H1 A
.nr H1 0
.Nh 1 IPCP Recommended Options
.RS
.LP
The following Configurations Options are recommended:
.LP
.RS
IP-Compression-Protocol -- with at least 4 slots, usually 16 slots.
.LP
IP-Address -- only on dial-up lines.
.RE
.RE
.LP
.XX SECURITY CONSIDERATIONS
.SH
Security Considerations
.LP
.RS
Security issues are not discussed in this memo.
.RE
.SH
.RE
.XX REFERENCES
.SH
References
.RS
.IP [1] 6
Simpson, W. A., "The Point-to-Point Protocol", RFC in progress.
.IP [2] 6
Postel, J., "Internet Protocol", RFC 791, USC/Information Sciences
Institute, September 1981.
.IP [3] 6
Jacobson, V., "Compressing TCP/IP Headers", RFC 1144, January 1990.
.IP [4] 6
Postel, J., "The TCP Maximum Segment Size Option and Related Topics",
RFC 879, USC/Information Sciences Institute, November 1983.
.IP [5] 6
Mogul, J.C., Deering, S.E., "Path MTU Discovery",
RFC 1191, November 1990.
.IP [6] 6
Reynolds, J., Postel,J., "Assigned Numbers", RFC 1060,
USC/Information Sciences Institute, March 1990.
.IP [7] 6
Perkins, D., Hobby, R., "Point-to-Point Protocol (PPP) initial configuration
options", RFC 1172, August 1990.
.RE
.SH
.RE
.XX ACKNOWLEDGEMENTS
.SH
Acknowledgments
.LP
.RS
Some of the text in this document is taken
from RFCs 1171 & 1172,
by Drew Perkins of Carnegie Mellon University,
and by Russ Hobby of the University of California at Davis.
.LP
Information leading to the expanded IP-Compression option provided
by Van Jacobson at SIGCOMM '90.
.LP
Bill Simpson helped with the document formatting.
.RE
.SH
.RE
.XX CHAIR'S ADDRESS
.SH
Chair's Address
.LP
.RS
The working group can be contacted via the current chair:
.LP
.RS
.nf
Brian Lloyd
Lloyd & Associates
3420 Sudbury Road
Cameron Park, California 95682
.sp
Phone: (916) 676-1147
.sp
EMail: brian@ray.lloyd.com
.fi
.LP
.RE
.SH
.RE
.XX AUTHOR'S ADDRESS
.SH
Author's Address
.LP
.RS
Questions about this memo can also be directed to:
.LP
.RS
.nf
Glenn McGregor
Merit Network, Inc.
1071 Beal Avenue
Ann Arbor, MI 48109-2103
.sp
Phone: (313) 763-1203
.sp
EMail: Glenn.McGregor@Merit.edu
.fi
.RE
.RE
.SH
.RE
.\" TOC
.bp \n(Pn
.af PN i
.if \n(VS>=40 .vs \n(VSu
.if \n(VS<=39 .vs \n(VSp
.ll \n(LLu
.lt \n(LTu
.ta \n(LLu-5n \n(LLuR
.in 0
.nf
.rs
.tl ''\f3\s+2Table of Contents\s-2\f1''
.sp
.XT
